const grammars = [
  "abap",
  "actionscript-3",
  "ada",
  "angular-expression",
  "angular-html",
  "angular-inline-style",
  "angular-inline-template",
  "angular-let-declaration",
  "angular-template-blocks",
  "angular-template",
  "angular-ts",
  "apache",
  "apex",
  "apl",
  "applescript",
  "ara",
  "asciidoc",
  "asm",
  "astro",
  "awk",
  "ballerina",
  "bat",
  "beancount",
  "berry",
  "bibtex",
  "bicep",
  "blade",
  "c",
  "cadence",
  "clarity",
  "clojure",
  "cmake",
  "cobol",
  "codeowners",
  "codeql",
  "coffee",
  "common-lisp",
  "coq",
  "cpp-macro",
  "cpp",
  "crystal",
  "csharp",
  "css",
  "csv",
  "cue",
  "cypher",
  "d",
  "dart",
  "dax",
  "desktop",
  "diff",
  "docker",
  "dotenv",
  "dream-maker",
  "edge",
  "elixir",
  "elm",
  "emacs-lisp",
  "erb",
  "erlang",
  "es-tag-css",
  "es-tag-glsl",
  "es-tag-html",
  "es-tag-sql",
  "es-tag-xml",
  "fennel",
  "fish",
  "fluent",
  "fortran-fixed-form",
  "fortran-free-form",
  "fsharp",
  "gdresource",
  "gdscript",
  "gdshader",
  "genie",
  "gherkin",
  "git-commit",
  "git-rebase",
  "gleam",
  "glimmer-js",
  "glimmer-ts",
  "glsl",
  "gnuplot",
  "go",
  "graphql",
  "groovy",
  "hack",
  "haml",
  "handlebars",
  "haskell",
  "haxe",
  "hcl",
  "hjson",
  "hlsl",
  "html-derivative",
  "html",
  "http",
  "hxml",
  "hy",
  "imba",
  "ini",
  "java",
  "javascript",
  "jinja-html",
  "jinja",
  "jison",
  "json",
  "json5",
  "jsonc",
  "jsonl",
  "jsonnet",
  "jssm",
  "jsx",
  "julia",
  "kotlin",
  "kusto",
  "latex",
  "lean",
  "less",
  "liquid",
  "log",
  "logo",
  "lua",
  "luau",
  "make",
  "markdown-vue",
  "markdown",
  "marko",
  "matlab",
  "mdc",
  "mdx",
  "mermaid",
  "mojo",
  "move",
  "narrat",
  "nextflow",
  "nginx",
  "nim",
  "nix",
  "nushell",
  "objective-c",
  "objective-cpp",
  "ocaml",
  "pascal",
  "perl",
  "php",
  "plsql",
  "po",
  "postcss",
  "powerquery",
  "powershell",
  "prisma",
  "prolog",
  "proto",
  "pug",
  "puppet",
  "purescript",
  "python",
  "qml",
  "qmldir",
  "qss",
  "r",
  "racket",
  "raku",
  "razor",
  "reg",
  "regexp",
  "rel",
  "riscv",
  "rst",
  "ruby",
  "rust",
  "sas",
  "sass",
  "scala",
  "scheme",
  "scss",
  "shaderlab",
  "shellscript",
  "shellsession",
  "smalltalk",
  "solidity",
  "soy",
  "sparql",
  "splunk",
  "sql",
  "ssh-config",
  "stata",
  "stylus",
  "svelte",
  "swift",
  "system-verilog",
  "systemd",
  "tasl",
  "tcl",
  "templ",
  "terraform",
  "tex",
  "toml",
  "ts-tags",
  "tsv",
  "tsx",
  "turtle",
  "twig",
  "typescript",
  "typespec",
  "typst",
  "v",
  "vala",
  "vb",
  "verilog",
  "vhdl",
  "viml",
  "vue-directives",
  "vue-html",
  "vue-interpolations",
  "vue-sfc-style-variable-injection",
  "vue",
  "vyper",
  "wasm",
  "wenyan",
  "wgsl",
  "wikitext",
  "wolfram",
  "xml",
  "xsl",
  "yaml",
  "zenscript",
  "zig"
];
const themes = [
  "andromeeda",
  "aurora-x",
  "ayu-dark",
  "catppuccin-frappe",
  "catppuccin-latte",
  "catppuccin-macchiato",
  "catppuccin-mocha",
  "dark-plus",
  "dracula-soft",
  "dracula",
  "everforest-dark",
  "everforest-light",
  "github-dark-default",
  "github-dark-dimmed",
  "github-dark-high-contrast",
  "github-dark",
  "github-light-default",
  "github-light-high-contrast",
  "github-light",
  "houston",
  "laserwave",
  "light-plus",
  "material-theme-darker",
  "material-theme-lighter",
  "material-theme-ocean",
  "material-theme-palenight",
  "material-theme",
  "min-dark",
  "min-light",
  "monokai",
  "night-owl",
  "nord",
  "one-dark-pro",
  "one-light",
  "plastic",
  "poimandres",
  "red",
  "rose-pine-dawn",
  "rose-pine-moon",
  "rose-pine",
  "slack-dark",
  "slack-ochin",
  "snazzy-light",
  "solarized-dark",
  "solarized-light",
  "synthwave-84",
  "tokyo-night",
  "vesper",
  "vitesse-black",
  "vitesse-dark",
  "vitesse-light"
];
export {
  grammars,
  themes
};
